import pygtk
import gtk
import _grope
# XXX For now, we'll use _grope directly. Once we have a good sense of what's
# going to be needed in general for general Python code using _grope, we'll put
# that stuff in a grope module, and import everything from there instead.


class GestureTester(object):

    def __init__(self):
        builder = gtk.Builder()
        builder.add_from_file("pygrope-gestures.xml")
        builder.connect_signals(self)
        self.window = builder.get_object("window1")
        self.window.show()

    def window_mapped(self, widget, data=None):
        # The gesture manager is only going to be needed for GTK2, since GTK3
        # will have the gesture API natively. Conversely, pygrope will only be
        # for GTK2, since PyGTK3 will having the bindings.
        gesture_manager = grope.GestureManager()
        # For the purpose of this example, we are registering all gestures; we
        # could limit this by choosing a different pygrope.GROPE_GESTURE_*
        # mask. Similarly, we're using one set of callbacks for all the
        # gestures; we could have different callbacks for different registered
        # gestures.
        gesture_manager.register_window(
            self.window, grope.GROPE_GESTURE_ALL, self.start_callback,
            self.update_callback, self.end_callback)

    def start_callback(self, window, gesture_type, gesture_event):
        print "received gesture start..."

    def update_callback(self, window, gesture_type, gesture_event):
        print "received gesture update..."

    def end_callback(self, window, gesture_type, gesture_event):
        print "received gesture end..."

    def quit(self, widget, data=None):
        gtk.main_quit()


if __name__ == "__main__":
    app = GestureTester()
    gtk.main()
